#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <errno.h>
#include <time.h>
#include <dirent.h>
#include <extdll.h>
#include <sdk_util.h>
#include <meta_api.h>
#include <cbase.h>

#include "webmod.h"

bool setVar(const char *name, const char *value, httpquery_t *query)
{
int i;
char str[1024];
	if(name[1]=='.')
	{
		switch(name[0])
		{
		case 'v': // internal scripting vars
			for(i=0;i<256 && query->vars[i].name[0] && strcmp(name+2,query->vars[i].name);i++)
				;
			if(i==256)
				return false;
LOG_DBG_PARSER(("Setting '%s' at index %d",name+2,i));
			if(!query->vars[i].name[0])
				strcpy(query->vars[i].name,name+2);
			strcpy(query->vars[i].value,value);
			return true;
			break;
		case 'c': // cvars
			if(value[0]=='"')
				sprintf(str,"%s %s\n",name+2,value);
			else
				sprintf(str,"%s \"%s\"\n",name+2,value);
			SERVER_COMMAND(str);
			return true;
			break;
		case 'h': // headers
			if(!strcmp(name+2,"contenttype"))
				strcpy(query->contenttype,value);
			else if(!strcmp(name+2,"location"))
				strcpy(query->location,value);
			else
				return false;
			return true;
			break;
		case 'W': // webmod vars
			if(!strcmp(name+2,"map"))
			{
				sprintf(str,"changelevel %s\n",value);
				SERVER_COMMAND(str);
			}
			else
				return false;
			return true;
			break;
		case 'C': // cookies
LOG_DBG_PARSER(("Want to set cookie '%s' to '%s'",name+2,value));
			sprintf(query->sendcookies,"%sSet-Cookie: %s=",query->sendcookies,name+2);
			for(i=0;value[i];i++)
			{
				if((value[i]>='0'&&value[i]<='9')||(value[i]>='a'&&value[i]<='z')||(value[i]>='A'&&value[i]<='Z'))
				{
					sprintf(query->sendcookies,"%s%c",query->sendcookies,value[i]);
				}
				else
					sprintf(query->sendcookies,"%s%%%02X",query->sendcookies,(char)(value[i])&0xFF);
			}
			strcat(query->sendcookies,"; path=/\n");
LOG_DBG_PARSER(("New SendCook is : '%s'",query->sendcookies));
			return true;
			break;
		default:
			return false;
			break;
		}
	}
	else
		return false;
}


bool getVar(char *out, char *in, httpquery_t *query,player_t *pPlayer)
{
int i,j;
time_t ts;

	if(in[1]=='.')
	{
		switch(in[0])
		{
		case 't': // time vars
			ts = time(NULL);
			if(!strcmp(in+2,"string"))
				strcpy(out,ctime(&ts));
			else
			{	
			struct tm *theTime;


				theTime = localtime(&ts);
				char days[7][10]={"Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"};
				char days2[7][4]={"Sun","Mon","Tue","Wed","Thu","Fri","Sat"};
				char months[12][10]={"January","February","March","April","May","June","July","August","September","October","November","December"};
				char months2[12][4]={"Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"};

				if(!strcmp(in+2,"hour"))
					sprintf(out,"%02d",theTime->tm_hour);
				else if(!strcmp(in+2,"min"))
					sprintf(out,"%02d",theTime->tm_min);
				else if(!strcmp(in+2,"sec"))
					sprintf(out,"%02d",theTime->tm_sec);
				else if(!strcmp(in+2,"month"))
					sprintf(out,"%02d",theTime->tm_mon);
				else if(!strcmp(in+2,"monthname"))
					strcpy(out,months[theTime->tm_mon-1]);
				else if(!strcmp(in+2,"monthname2"))
					strcpy(out,months2[theTime->tm_mon-1]);
				else if(!strcmp(in+2,"weekday"))
					sprintf(out,"%d",theTime->tm_wday);
				else if(!strcmp(in+2,"weekdayname"))
					strcpy(out,days[theTime->tm_wday]);
				else if(!strcmp(in+2,"weekdayname2"))
					strcpy(out,days2[theTime->tm_wday]);
				else if(!strcmp(in+2,"day"))
					sprintf(out,"%02d",theTime->tm_mday);
				else if(!strcmp(in+2,"year"))
					sprintf(out,"%04d",theTime->tm_year+1900);
				else if(!strcmp(in+2,"year2"))
					sprintf(out,"%02d",theTime->tm_year%100);
				else
					return false;
			}
			return true;
			break;
		case 'I': // other plugins interfaces
			if(!strcmp(in+2,"p2"))
			{
			p2if_t *p2_interface;
				p2_interface=(p2if_t*)(atoi(CVAR_GET_STRING("p2_interface")));
				if(p2_interface)
				{
					sprintf(out,"%d",p2_interface->version);
				}
				else
					strcpy(out,"0");
			}
			else
				return false;
			return true;
			break;
		case 'i': // plugin interfaces recognized by this webmod
			if(!strcmp(in+2,"p2"))
				sprintf(out,"%d",P2IF);
			else
				return false;
			return true;
			break;
		case 'v': // internal user var
			for(i=0;i<256 && query->vars[i].name[0] && strcmp(in+2,query->vars[i].name);i++)
				;
			if(i==256 || query->vars[i].name[0]=='\0')
				return false;
LOG_DBG_PARSER(("Found var '%s' at index %d",in+2,i));
			strcpy(out,query->vars[i].value);
			return true;
			break;
		case 'm':
			if(!strcmp(in+2,"name"))
				strcpy(out,query->currentmapname);
			else
				return false;
			return true;
		case 'C': // COOKIE var
			formDecode(in+2,query->cookies,out,true);
			return true;
			break;
		case 'G': // GET var
			formDecode(in+2,query->get,out,true);
			return true;
			break;
		case 'P': // POST var
			formDecode(in+2,query->post,out,true);
			return true;
			break;
		case 'p': // player var
			if(pPlayer==NULL)
				return false;
			else if(!strcmp(in+2,"name"))
				strcpy(out,STRING(pPlayer->pEdict->v.netname));
			else if(!strcmp(in+2,"authid"))
			{
				strcpy(out,GETPLAYERAUTHID(pPlayer->pEdict));
				if(!strcmp(out,"4294967295"))
					strcpy(out,"none");
			}
			else if(!strcmp(in+2,"frags"))
				sprintf(out,"%d",(int)(pPlayer->pEdict->v.frags));
			else if(!strcmp(in+2,"deaths"))
				sprintf(out,"%d",pPlayer->deaths);
			else if(!strcmp(in+2,"id"))
				sprintf(out,"%d",pPlayer->index);
			else if(!strcmp(in+2,"team"))
				strcpy(out,pPlayer->team?pPlayer->team:"");
			else if(!strcmp(in+2,"teamid"))
				sprintf(out,"%d",pPlayer->team_id);
			else if(!strcmp(in+2,"uid"))
				sprintf(out,"%d",GETPLAYERUSERID(pPlayer->pEdict));
			else if(!strcmp(in+2,"ctime"))
			{
				if(pPlayer->ingame || (pPlayer->connected && pPlayer->connected_since+(int)CVAR_GET_FLOAT("sv_timeout")>time(NULL)))
				{
				int hours,minutes,seconds;

					seconds = time(NULL)-(pPlayer->connected_since);
					minutes = (seconds/60)%60;
					hours = seconds / 3600;
					seconds = seconds%60;
					sprintf(out,"%02d:%02d:%02d",hours,minutes,seconds);
				}
				else
					strcpy(out,"0");
			}
			else if(!strcmp(in+2,"ptime"))
			{

				if(pPlayer->ingame)

				{
				int hours,minutes,seconds;
					seconds = time(NULL)-(pPlayer->ingame_since);
					minutes = (seconds/60)%60;
					hours = seconds / 3600;
					seconds = seconds%60;
					sprintf(out,"%02d:%02d:%02d",hours,minutes,seconds);
				}
				else
					strcpy(out,"0");
			}
			else if(!strcmp(in+2,"ping"))
			{
			int pPing,pLoss;
				PLAYER_CNX_STATS(pPlayer->pEdict,&pPing,&pLoss);
				sprintf(out,"%d",pPing);
			}
			else if(!strcmp(in+2,"loss"))
			{
			int pPing,pLoss;
				PLAYER_CNX_STATS(pPlayer->pEdict,&pPing,&pLoss);
				sprintf(out,"%d",pLoss);
			}
			else if(!strcmp(in+2,"ip"))
				strcpy(out,pPlayer->ip);
			else if(!strcmp(in+2,"bomb"))
				strcpy(out,((pPlayer->pEdict->v.deadflag==DEAD_NO)&&pPlayer->bomb?"1":"0"));
			else if(!strcmp(in+2,"vip"))
				strcpy(out,pPlayer->vip?"1":"0");
			else if(!strcmp(in+2,"ingame"))
				strcpy(out,pPlayer->ingame?"1":"0");
			else if(!strcmp(in+2,"connected"))
				strcpy(out,(pPlayer->ingame || (pPlayer->connected && pPlayer->connected_since+(int)CVAR_GET_FLOAT("sv_timeout")>time(NULL)))?"1":"0");
			else if(!strcmp(in+2,"alive"))
				strcpy(out,((pPlayer->pEdict->v.deadflag==DEAD_NO)?"1":"0"));
			else if(!strcmp(in+2,"dead"))
				strcpy(out,((pPlayer->pEdict->v.deadflag==DEAD_NO)?"0":"1"));
			else if(!strcmp(in+2,"health"))
				sprintf(out,"%d",(int)(pPlayer->pEdict->v.health));
			else if(!strcmp(in+2,"armor"))
				sprintf(out,"%d",(int)(pPlayer->pEdict->v.armorvalue));
			else if(!strcmp(in+2,"x"))
				sprintf(out,"%d",(int)(((vec3_t)(pPlayer->pEdict->v.origin))[0]));
			else if(!strcmp(in+2,"y"))
				sprintf(out,"%d",(int)(((vec3_t)(pPlayer->pEdict->v.origin))[1]));
			else if(!strcmp(in+2,"z"))
				sprintf(out,"%d",(int)(((vec3_t)(pPlayer->pEdict->v.origin))[2]));
			else
				return false;
LOG_DBG_PARSER(("PlayerVar '%s' : '%s'",in+2,out));
			return true;
			break;
		case 'c': // cvar
			strcpy(out,CVAR_GET_STRING(in+2));
LOG_DBG_PARSER(("CVar '%s' : '%s'",in+2,out));
			return true;
		case 'W': // internal var
			if(!strcmp(in+2,"maxplayers"))
				sprintf(out,"%d",gpGlobals->maxClients);
			else if(!strcmp(in+2,"map"))
				strcpy(out,STRING(gpGlobals->mapname));
			else if(!strcmp(in+2,"url"))
				strcpy(out,query->url);
			else if(!strcmp(in+2,"clientip"))
				strcpy(out,query->clientip);
			else if(!strcmp(in+2,"moddir"))
				GET_GAME_DIR(out);
			else if(!strcmp(in+2,"users"))
			{
			int tot=0;
				for(j=1;j<=gpGlobals->maxClients;j++)
				{
					if(INDEXPLAYER(j)->ingame || (INDEXPLAYER(j)->connected && INDEXPLAYER(j)->connected_since+(int)CVAR_GET_FLOAT("sv_timeout")>time(NULL)))
					{
						tot++;
					}
				}
				sprintf(out,"%d",tot);
			}
			else if(!strcmp(in+2,"players"))
			{
			int tot=0;
				for(j=1;j<=gpGlobals->maxClients;j++)
					if(INDEXPLAYER(j)->ingame)
						tot++;
				sprintf(out,"%d",tot);
			}
			else if(!strcmp(in+2,"OS"))
			{
#ifdef WIN32
				strcpy(out,"Win32");
#else
				if(!freebsd)
					strcpy(out,"Linux");
				else
					strcpy(out,"FreeBSD");
#endif
			}
			else if(!strcmp(in+2,"os"))
			{
#ifdef WIN32
				strcpy(out,"win32");
#else
				if(!freebsd)
					strcpy(out,"linux");
				else
					strcpy(out,"freebsd");
#endif
			}
			else if(!strcmp(in+2,"uptime"))
			{
			int hours,minutes,seconds;

				seconds = time(NULL)-up_since;
				minutes = (seconds/60)%60;
				hours = seconds / 3600;
				seconds = seconds%60;
				sprintf(out,"%02d:%02d:%02d",hours,minutes,seconds);
			}
			else
				return false;
LOG_DBG_PARSER(("InternalVar '%s' : '%s'",in+2,out));

			return true;
		default:
			return false;
		}
	}
	else
		return false;
}

bool execFunction(char *parsed,const char *fname, httpquery_t *query, player_t *pPlayer, const char params[16][256])
{
char str[1024];
int silent;
char res[MAX_FILE_SIZE+1];


	if(fname[0]=='@')
		silent = 1;
	else
		silent = 0;

	res[0]='\0';

	if(!strcmp(fname+silent,"rcon"))
	{
		parseNotScript(res,params[0],query,pPlayer);
		if(res[0]!='\0')
		{
			sprintf(str,"%s\n",res);
			SERVER_COMMAND(str);
			if(!silent)
				strcat(parsed,"1");
		}
		else
		{
			if(!silent)
				strcat(parsed,"0");
		}
		return true;
	}
	else if(!strcmp(fname+silent,"player"))
	{
		// {@player:p.name=something:what to do}
		// {@player:p.uid=number:what to do}
	int i;

		for(i=1;i<=gpGlobals->maxClients;i++)
		{
			if(INDEXPLAYER(i)->ingame)
			{
				res[0]='\0';
				parseScript(res,params[0],query,INDEXPLAYER(i));
				if(strcmp(res,"0"))
				{
					parseNotScript(parsed,params[1],query,INDEXPLAYER(i));
					break;
				}
			}
		}
		return true;
	}
	else if(!strcmp(fname+silent,"user"))
	{
		// {@user:p.name=something:what to do}
		// {@user:p.uid=number:what to do}
	int i;

		for(i=1;i<=gpGlobals->maxClients;i++)
		{
			if((INDEXPLAYER(i)->ingame || (INDEXPLAYER(i)->connected && INDEXPLAYER(i)->connected_since+(int)CVAR_GET_FLOAT("sv_timeout")>time(NULL))))
			{
				res[0]='\0';
				parseScript(res,params[0],query,INDEXPLAYER(i));
				if(strcmp(res,"0"))
				{
					parseNotScript(parsed,params[1],query,INDEXPLAYER(i));
					break;
				}
			}
		}
		return true;
	}
	else if(!strcmp(fname+silent,"teamscore"))
	{
	int i;
		for(i=0;i<32;i++)
		{
			if(!strcmp(teams[i].name,params[0]))
				break;
		}
		sprintf(parsed,"%s%d",parsed,i<32?teams[i].score:0);
		return true;
	}
	else if(!strcmp(fname+silent,"execclient"))
	{
	int i;
	int uid;
		
		parseScript(res,params[0],query,pPlayer);
		uid = atoi(res);

		for(i=1;i<=gpGlobals->maxClients;i++)
		{
			if((INDEXPLAYER(i)->ingame || (INDEXPLAYER(i)->connected && INDEXPLAYER(i)->connected_since+(int)CVAR_GET_FLOAT("sv_timeout")>time(NULL))) && INDEXPLAYER(i)->pEdict && uid==GETPLAYERUSERID(INDEXPLAYER(i)->pEdict))
			{
				res[0]='\0';
				parseNotScript(res,params[1],query,INDEXPLAYER(i));
				sprintf(str,"%s\n",res);
				CLIENT_COMMAND(MYINDEXENT(i),str);
				if(!silent)
					strcat(parsed,"1");
				return true;
			}
		}
		if(!silent)
			strcat(parsed,"0");
		return true;
	}
	else if(!strcmp(fname+silent,"file_exists"))
	{
		parseNotScript(res,params[0],query,pPlayer);
		if(res[0]!='\0')
		{
		FILE *f;
			f=fopen(res,"rb");
			if(f!=NULL)
			{
				if(!silent)
					strcat(parsed,"1");
				fclose(f);
			}
			else
				if(!silent)
					strcat(parsed,"0");
		}
		else
			if(!silent)
				strcat(parsed,"0");
		return true;
	}
	else if(!strcmp(fname+silent,"trim"))
	{
	int lastpos,i;

		if(silent)
			return true;

		parseNotScript(res,params[0],query,pPlayer);

		for(i=0;charInString(res[i]," \t\n\r");i++)
			;
		for(lastpos=strlen(res)-1;lastpos>=0&&charInString(res[lastpos]," \t\n\r");lastpos--)
			;
		str[1]='\0';
		while(i<=lastpos)
		{
			str[0]=res[i];
			strcat(parsed,str);
			i++;
		}

		return true;
	}
	else if(!strcmp(fname+silent,"sleep"))
	{
		sleep(atoi(params[0]));
		return true;
	}
	else if(!strcmp(fname+silent,"p2_known"))
	{
	p2if_t *p2_interface;

		p2_interface=(p2if_t*)(atoi(CVAR_GET_STRING("p2_interface")));
		if(p2_interface)
		{
			if(p2_interface->version==P2IF)
			{
				sprintf(parsed,"%s%d",parsed,(*(p2_interface->getKnownPlayers))());
			}
			else
				strcat(parsed,"<b>ERROR:</b> incompatible p2 memory interface");
		}
		else
			strcat(parsed,"<b>ERROR:</b> no p2 memory interface found");

		return true;
	}
	else if(!strcmp(fname+silent,"p2_name"))
	{
	p2if_t *p2_interface;
	char zeName[33];

		p2_interface=(p2if_t*)(atoi(CVAR_GET_STRING("p2_interface")));
		if(p2_interface)
		{
			if(p2_interface->version==P2IF)
			{
				parseNotScript(res,params[0],query,pPlayer);
				memset(zeName,0,33);
				strncpy(zeName,res,32);
				sprintf(parsed,"%s%d",parsed,(*(p2_interface->isKnownName))(zeName));
			}
			else
				strcat(parsed,"<b>ERROR:</b> incompatible p2 memory interface");
		}
		else
			strcat(parsed,"<b>ERROR:</b> no p2 memory interface found");

		return true;
	}
	else if(!strcmp(fname+silent,"p2_knownid"))
	{
	p2if_t *p2_interface;

		p2_interface=(p2if_t*)(atoi(CVAR_GET_STRING("p2_interface")));
		if(p2_interface)
		{
			if(p2_interface->version==P2IF)
			{
				parseNotScript(res,params[0],query,pPlayer);
				sprintf(parsed,"%s%d",parsed,(*(p2_interface->isKnownID))(atoi(res)));
			}
			else
				strcat(parsed,"<b>ERROR:</b> incompatible p2 memory interface");
		}
		else
			strcat(parsed,"<b>ERROR:</b> no p2 memory interface found");

		return true;
	}
	else
		return false;
}


bool strIsScript(const char *str)
{
int i;

	for(i=0;str[i];i++)
	{
		if(str[i]=='{')
			return true;
		if(str[i]=='\\' && str[i+1]=='{')
			i++;
	}
	return false;
}



bool charInString(const char c, const char *str)
{
int i;

	for(i=0;str[i];i++)
		if(str[i]==c)
			return true;
	return false;
}



void parseNotScript(char *parsed,const char *stp,httpquery_t *query,player_t *pPlayer)
{
char top[MAX_FILE_SIZE+1];
int i,j;
int len,level;
char s[2];

	len=strlen(stp);
	s[1]='\0';
	j=0;
	for(i=0;i<len;i++)
	{
		if(stp[i]!='{') // not a script block
		{
			if(stp[i]=='\\' && stp[i+1]=='{') // unescape only if '{'
				i++;
			s[0]=stp[i];
			strcat(parsed,s);
		}
		else // script block : extract it
		{
LOG_DBG_PARSER(("Script block at pos. %d ; extracting...",i));
			level=1;
			i++;

			for(j=0;level>0&&stp[i];i++) // parse until the closing bracket
			{
				if(stp[i]=='\\' && charInString(stp[i+1],"{}")) // escaped character, unescape only if { or }
					top[j++]=stp[++i];
				else // not an escaped character
				{
					if(stp[i]=='}') // closing bracket
					{
						level--;
LOG_DBG_PARSER(("End of sub-block ; now level=%d",level));
					}
					else if(stp[i]=='{') // sub-block
					{
						level++;
LOG_DBG_PARSER(("Sub-block ; now level=%d",level));
					}
					top[j++]=stp[i];
				} // (not an escaped character)
			} // (parsing until closing bracket)
			top[--j]='\0'; // close our block ; if it was closed because of EOF : too bad, incorrect syntax :-p
			i--;
LOG_DBG_PARSER(("End of script block : '%s'",top));
			parseScript(parsed,top,query,pPlayer);
		} // (script block)
	} // (for)

}

void parseScript(char *parsed,const char *stp,httpquery_t *query,player_t *pPlayer)
{
LOG_DBG_PARSER(("Script part : '%s'",stp));
char top[MAX_FILE_SIZE+1];
int i,j,k;
int level;
char res[MAX_FILE_SIZE+1];
char fname[256];
char params[16][256];

	if(stp[0]=='#')
		return;

	memset(params,0,16*256);

	if(stp[0]=='@') // function call
	{
		for(i=1,j=0;stp[i] && stp[i]!=':';i++) // get function name
			fname[j++]=stp[i];
		fname[j]='\0';
LOG_DBG_PARSER(("Function name : '%s'",fname));

		k=0;
		while(stp[i]) // get function parameters
		{
			i++;
			level=0;
			for(j=0;stp[i] && (level || stp[i]!=':');i++) // parse until '\0', '?'(test) or ':'(assignment)
			{
				if(stp[i]=='\\' && stp[i+1]==':' && !level) // escaped character, unescape only if ':'
				{
					params[k][j++]=stp[++i];
				}
				else // not an escaped character
				{
					if(stp[i]=='}') // closing bracket
						level--;
					else if(stp[i]=='{') // sub-block
						level++;
					params[k][j++]=stp[i];
				} // (not an escaped character)
			} // (parsing until closing bracket)
			params[k][j]='\0'; // close our block
LOG_DBG_PARSER(("Param #%d : '%s'",k,params[k]));
			top[0]='\0';

			// we don't parse parameters here anymore !

LOG_DBG_PARSER(("Param #%d : '%s'",k,params[k]));
			k++;
		}

		i--;

		if(!execFunction(parsed,fname,query,pPlayer,params)) // if unknown func
			strcat(parsed,stp);

	} // (function call)
	else if(stp[0]=='<') // include a file : {<filename} (parse) or {<<filename} (don't parse)
	{
	FILE *f;
	int dontparse = 0;
	char filename[1025];

		if(stp[1]=='<')
			dontparse=1;

		GET_GAME_DIR(top);
		if(dontparse)
			strcat(top,"/../");
		else
			strcat(top,"/addons/w/www/");

		filename[0]='\0';
		parseNotScript(filename,stp+1+dontparse,query,pPlayer);
		strcat(top,filename);

		if((f=fopen(top,"rb"))==NULL)
		{
			strcat(parsed,stp);
		}
		else
		{
			fclose(f);
			readFile(res,top,NULL);
			top[0]='\0';
			if(dontparse)
			{
				strcat(parsed,res);
			}
			else
			{
				parseNotScript(top,res,query,pPlayer);
				strcat(parsed,top);
			}
		}

	} // (include a file)
	else if(stp[0]=='>') // write to file : {>filename:content} (overwrite) or {>>filename:content} (append)
	{
	FILE *f;
	char filename[1025];
	int blockpart = 0; // 0:filename 1:content
	int append = 0;

		if(stp[1]=='>')
			append = 1;

		res[0]='\0';
		filename[0]='\0';

//LOG_MESSAGE(PLID,"FileWrite ; let's parse...");

		level=0;
		i=1+append;

		// extract all ("levels" system) until : '\0' ':'
		do
		{
			for(j=0;stp[i] && (level || stp[i]!=':');i++) // parse until '\0', '?'(test) or ':'(assignment)
			{
				if(stp[i]=='\\' && stp[i+1]==':' && !level) // escaped character, unescape only if '?' or ':'
					top[j++]=stp[++i];
				else // not an escaped character
				{
					if(stp[i]=='}') // closing bracket
						level--;
					else if(stp[i]=='{') // sub-block
						level++;
					top[j++]=stp[i];
				} // (not an escaped character)
			} // (parsing until end)


			top[j]='\0'; // close our block

			if(!blockpart)
			{
				parseNotScript(filename,top,query,pPlayer);
//LOG_MESSAGE(PLID,"Got a FileName : '%s'",filename);
			}
			else
			{
				parseNotScript(res,top,query,pPlayer);
//LOG_MESSAGE(PLID,"Got a Content : '%s'",res);
			}

			blockpart++;

			if(stp[i])
				i++;
		}
		while(stp[i]);

//LOG_MESSAGE(PLID,"FILE WRITE : '%s'\n\"%s\"",filename,res);

		GET_GAME_DIR(top);
		strcat(top,"/../");
		strcat(top,filename);

		if(append)
			f = fopen(top,"ab");
		else
			f = fopen(top,"wb");

		if(f==NULL)
		{
			sprintf(res,"<br><b>WARNING:</b> could not write to file '%s'<br>",top);
			strcat(parsed,res);
		}
		else
		{
			fputs(res,f);
			fclose(f);
		}

	} // (write to file)
	else // no special char at the beginning
	{
		if(stp[0]=='L'&&stp[1]=='.'&&stp[3]==':') // loop
		{
		int currentblock;
		char sep='\0';
		char varname[33];
		char varvalue[512];
		char mylist[MAX_FILE_SIZE+1];
		DIR *dirptr;
		struct dirent *direntry;

LOG_DBG_PARSER(("Loop spotted !"));
			switch(stp[2])
			{
			case 'p': // players list (ingame)
				for(k=1;k<=gpGlobals->maxClients;k++)
					if(INDEXPLAYER(k)->ingame)
						parseNotScript(parsed,stp+4,query,INDEXPLAYER(k));
				break;
			case 'u': // users list (ingame or connecting)
				for(k=1;k<=gpGlobals->maxClients;k++)
					if((INDEXPLAYER(k)->ingame || (INDEXPLAYER(k)->connected && INDEXPLAYER(k)->connected_since+(int)CVAR_GET_FLOAT("sv_timeout")>time(NULL))))
						parseNotScript(parsed,stp+4,query,INDEXPLAYER(k));
				break;
			case 'm':
				GET_GAME_DIR(top);
				strcat(top,"/maps");
				dirptr = opendir(top);
				query->currentmapname[0]='\0';
				if(dirptr)
				{
					char nxtmap[257];
					nxtmap[0]='\0';
					direntry=readdir(dirptr);
					while(direntry!=NULL || nxtmap[0]!='\0')
					{
						if(!direntry)
						{
							strcpy(query->currentmapname,nxtmap);
							parseNotScript(parsed,stp+4,query,pPlayer);
							rewinddir(dirptr);
							nxtmap[0]='\0';
							direntry=readdir(dirptr);
						}
						i=strlen(direntry->d_name);
						if(!strcmp(".bsp",(direntry->d_name)+i-4))
						{
							(direntry->d_name)[i-4]='\0';
							if(strcmp(direntry->d_name,query->currentmapname)>0)
							{
								if(nxtmap[0]=='\0' || strcmp(nxtmap,direntry->d_name)>0)
									strcpy(nxtmap,direntry->d_name);
							}
						}
						direntry=readdir(dirptr);
					}
					closedir(dirptr);
				}
				query->currentmapname[0]='\0';
				break;
			case 'l': // list : {L.l:<varname>:<element,element>:<do something with {<varname>}>}
				i=4;
				currentblock=0;
				varname[0]='\0';
				do
				{
					level=0;
					top[0]='\0';
					for(j=0;stp[i] && (level || stp[i]!=':');i++) // parse until '\0' or ':'(assignment)
					{
						if(stp[i]=='\\' && stp[i+1]==':' && !level) // escaped character, unescape only if ':'
						{
							top[j++]=stp[++i];
						}
						else // not an escaped character
						{
							if(stp[i]=='}') // closing bracket
								level--;
							else if(stp[i]=='{') // sub-block
								level++;
							top[j++]=stp[i];
						} // (not an escaped character)
					} // (parsing until end or ':')
					top[j]='\0'; // close our block
//LOG_MESSAGE(PLID,"Got a LOOP.LIST block : '%s'",top);
					if(stp[i]!='\0')
						i++;
					switch(currentblock)
					{
					case 0:
						parseNotScript(varname,top,query,pPlayer);
						break;
					case 1:
						strcpy(mylist,top);
						break;
					case 2:
						strcpy(res,top);
						break;
					default:
						break;
					}
					currentblock++;
				}
				while(stp[i]&&currentblock<3); // parse until the end

				i=0;
				do
				{
					level=0;
					top[0]='\0';
					for(j=0;mylist[i] && (level || mylist[i]!=',');i++) // parse until '\0', or ','(list separator)
					{
						if(mylist[i]=='\\' && mylist[i+1]==',' && !level) // escaped character, unescape only if ','
							top[j++]=mylist[++i];
						else // not an escaped character
						{
							if(mylist[i]=='}') // closing bracket
								level--;
							else if(mylist[i]=='{') // sub-block
								level++;
							top[j++]=mylist[i];
						} // (not an escaped character)
					} // (parsing until end or ',')
					top[j]='\0'; // close our block
//LOG_MESSAGE(PLID,"Got an element : '%s'",top);
					varvalue[0]='\0';
					parseNotScript(varvalue,top,query,pPlayer);
					setVar(varname,varvalue,query);
					parseNotScript(parsed,res,query,pPlayer);
					if(mylist[i]!='\0')
						i++;
				}
				while(mylist[i]); // parse until the end
				break;
			case 'L': // second list : {L.L:<varname>:<separator>:<element,element>:<do something with {<varname>}>}
				i=4;
				currentblock=0;
				varname[0]='\0';
				do
				{
					level=0;
					top[0]='\0';
					for(j=0;stp[i] && (level || stp[i]!=':');i++) // parse until '\0' or ':'(assignment)
					{
						if(stp[i]=='\\' && stp[i+1]==':' && !level) // escaped character, unescape only if ':'
						{
							top[j++]=stp[++i];
						}
						else // not an escaped character
						{
							if(stp[i]=='}') // closing bracket
								level--;
							else if(stp[i]=='{') // sub-block
								level++;
							top[j++]=stp[i];
						} // (not an escaped character)
					} // (parsing until end or ':')
					top[j]='\0'; // close our block
//LOG_MESSAGE(PLID,"Got a LOOP.LIST block : '%s'",top);
					if(stp[i]!='\0')
						i++;
					switch(currentblock)
					{
					case 0:
						parseNotScript(varname,top,query,pPlayer);
						break;
					case 1:
						mylist[0]='\0';
						parseNotScript(mylist,top,query,pPlayer);
						sep = mylist[0];
						break;
					case 2:
						mylist[0]='\0';
						parseNotScript(mylist,top,query,pPlayer);
						break;
					case 3:
						strcpy(res,top);
						break;
					default:
						break;
					}
					currentblock++;
				}
				while(stp[i]&&currentblock<4); // parse until the end

				i=0;
				do
				{
					level=0;
					top[0]='\0';
					for(j=0;mylist[i] && (level || mylist[i]!=sep);i++) // parse until '\0' or separator
					{
						if(mylist[i]=='\\' && mylist[i+1]==sep && !level)
							top[j++]=mylist[++i];
						else // not an escaped character
						{
							if(mylist[i]=='}') // closing bracket
								level--;
							else if(mylist[i]=='{') // sub-block
								level++;
							top[j++]=mylist[i];
						} // (not an escaped character)
					} // (parsing until end or ',')
					top[j]='\0'; // close our block
//LOG_MESSAGE(PLID,"Got an element : '%s'",top);
					varvalue[0]='\0';
					parseNotScript(varvalue,top,query,pPlayer);
					setVar(varname,varvalue,query);
					parseNotScript(parsed,res,query,pPlayer);
					if(mylist[i]!='\0')
						i++;
				}
				while(mylist[i]); // parse until the end
				break;
			case 'w': // while : {L.w:<test>:<action>}
				i=4;
				currentblock=0;
				do
				{
					level=0;
					top[0]='\0';
					for(j=0;stp[i] && (level || stp[i]!=':');i++) // parse until '\0' or ':'(assignment)
					{
						if(stp[i]=='\\' && stp[i+1]==':' && !level) // escaped character, unescape only if ':'
						{
							top[j++]=stp[++i];
						}
						else // not an escaped character
						{
							if(stp[i]=='}') // closing bracket
								level--;
							else if(stp[i]=='{') // sub-block
								level++;
							top[j++]=stp[i];
						} // (not an escaped character)
					} // (parsing until end or ':')
					top[j]='\0'; // close our block
//LOG_MESSAGE(PLID,"Got a LOOP.LIST block : '%s'",top);
					if(stp[i]!='\0')
						i++;
					switch(currentblock)
					{
					case 0:
						strcpy(varvalue,top);
						break;
					case 1:
						break;
					default:
						break;
					}
					currentblock++;
				}
				while(stp[i]&&currentblock<2); // parse until the end

				varname[0]='\0';
				parseScript(varname,varvalue,query,pPlayer);
				while(atoi(varname))
				{
					parseNotScript(parsed,top,query,pPlayer);
					varname[0]='\0';
					parseScript(varname,varvalue,query,pPlayer);
				}

				break;
			default:
				strcat(parsed,stp);
			}
		}
		else // not a loop
		{
		char why;

			res[0]='\0';
			level=0;


			// extract all ("levels" system)
			for(j=0,i=0;stp[i] && (level || !charInString(stp[i],"?:=!><&|+-*/@"));i++)
			{
				if(stp[i]=='\\' && charInString(stp[i],"?:=!><&|+-*/@") && !level) // escaped character, unescape only if would be a closing one
					top[j++]=stp[++i];
				else // not an escaped character
				{
					if(stp[i]=='}') // closing bracket
						level--;
					else if(stp[i]=='{') // sub-block
						level++;
					top[j++]=stp[i];
				} // (not an escaped character)
			} // (extract)
			top[j]='\0'; // close our block
			
			why=stp[i]; // why did we stop parsing ?

			if(why=='\0') // {hello sir} : have a text, maybe a var
			{
				strcpy(res,top);
				top[0]='\0';
LOG_DBG_PARSER(("Maybe a var ? '%s'",res));
				parseNotScript(top,res,query,pPlayer);
LOG_DBG_PARSER(("Parsed potential var : '%s'",top));
				if(top[1]=='.') // if seems to be a var
				{
					if(getVar(res,top,query,pPlayer)) // if correct var
						strcat(parsed,res);
					else // incorrect var
						strcat(parsed,top);
				}
				else // not a var
				{
					res[0]='\0';
					parseNotScript(res,top,query,pPlayer);
					strcat(parsed,res);
				}
			}
			else if(why=='?') // {something?anything:else} : have to test something, then return anything or else
			{
			char *endptr;
			int varValue;
			bool testres;

				res[0]='\0';
				if(strIsScript(top))
					parseNotScript(res,top,query,pPlayer); // !!! {var?a:b} will not evaluate 'var' ; {{var}?a:b} will
				else
					parseScript(res,top,query,pPlayer); // WORKAROUND

				if(!strlen(res))
					testres = false;
				else
				{
					varValue = strtol(res,&endptr,10);
					if(endptr==res || *endptr!='\0')
					{
//LOG_MESSAGE(PLID,"Not a number : '%s'",res);
						testres = true;
					}
					else
					{
//LOG_MESSAGE(PLID,"Number : '%s'=%d",res,varValue);
						if(varValue)
							testres = true;
						else
							testres = false;
					}
				}

				i++;
				do
				{
					level=0;
					top[0]='\0';
					for(j=0;stp[i] && (level || stp[i]!=':');i++) // parse until '\0' or ':'(separator)
					{
						if(stp[i]=='\\' && stp[i+1]==':' && !level) // escaped character, unescape only if ':'
						{
							top[j++]=stp[++i];
						}
						else // not an escaped character
						{
							if(stp[i]=='}') // closing bracket
								level--;
							else if(stp[i]=='{') // sub-block
								level++;
							top[j++]=stp[i];
						} // (not an escaped character)
					} // (parsing until ':' separator)
					top[j]='\0'; // close our block
//LOG_DBG_PARSER(("Got a block : '%s'",top));
					if(stp[i]!='\0')
						i++;
					testres = !testres;
				}
				while(testres); // parse again if 'false' statement required

				i--;

LOG_DBG_PARSER(("Statement : '%s'",top));

				res[0]='\0';
				parseNotScript(res,top,query,pPlayer);
				strcat(parsed,res);
			}
			else
			{
				handleBinaryOperand(parsed, why,top,stp+i+1,query,pPlayer);
			}
		}
	} // (no special char at start)
}

void handleBinaryOperand(char *parsed, char why, const char *first, const char *second, httpquery_t *query,player_t *pPlayer)
{
char res[MAX_FILE_SIZE+1];
char res2[MAX_FILE_SIZE+1];
int j;

	if(why==':') // {varname:our new value}
	{
		res[0]='\0';
		res2[0]='\0';
LOG_DBG_PARSER(("Assignment ! assign '%s' to '%s'",second,first));
		parseNotScript(res,first,query,pPlayer);
LOG_DBG_PARSER(("Var to assign got name '%s'",res));					
		parseNotScript(res2,second,query,pPlayer);
		setVar(res,res2,query);
LOG_DBG_PARSER(("Assign '%s' : '%s'",res,res2));
	}
	else if(why=='>')
	{
		res[0]='\0';
		res2[0]='\0';

		parseScript(res,first,query,pPlayer);
		if(second[0]=='=')
		{
			parseScript(res2,second+1,query,pPlayer);
			strcat(parsed,(atoi(res)>=atoi(res2))?"1":"0");
		}
		else
		{
			parseScript(res2,second,query,pPlayer);
			strcat(parsed,(atoi(res)>atoi(res2))?"1":"0");
		}
	}
	else if(why=='<')
	{
		res[0]='\0';
		res2[0]='\0';

		parseScript(res,first,query,pPlayer);
		if(second[0]=='=')
		{
			parseScript(res2,second+1,query,pPlayer);
			strcat(parsed,(atoi(res)<=atoi(res2))?"1":"0");
		}
		else
		{
			parseScript(res2,second,query,pPlayer);
			strcat(parsed,(atoi(res)<atoi(res2))?"1":"0");
		}
	}
	else if(why=='+')
	{
		res[0]='\0';
		res2[0]='\0';

		parseScript(res,first,query,pPlayer);
		parseScript(res2,second,query,pPlayer);

		sprintf(parsed,"%s%d",parsed,atoi(res)+atoi(res2));
	}
	else if(why=='-')
	{
		res[0]='\0';
		res2[0]='\0';

		parseScript(res,first,query,pPlayer);
		parseScript(res2,second,query,pPlayer);

		sprintf(parsed,"%s%d",parsed,atoi(res)-atoi(res2));
	}
	else if(why=='*')
	{
		res[0]='\0';
		res2[0]='\0';

		parseScript(res,first,query,pPlayer);
		parseScript(res2,second,query,pPlayer);

		sprintf(parsed,"%s%d",parsed,atoi(res)*atoi(res2));
	}
	else if(why=='/')
	{
		res[0]='\0';
		res2[0]='\0';

		parseScript(res,first,query,pPlayer);
		parseScript(res2,second,query,pPlayer);

		sprintf(parsed,"%s%d",parsed,atoi(res)/atoi(res2));
	}
	else if(why=='=') // {something=something else}
	{
LOG_DBG_PARSER(("Test : ="));

		res[0]='\0';
		res2[0]='\0';
		parseScript(res,first,query,pPlayer);

LOG_DBG_PARSER(("Want to parse : '%s'",second));
		parseScript(res2,second,query,pPlayer);
LOG_DBG_PARSER(("Compare == '%s' and '%s'",res,res2));

		if(!strcmp(res,res2))
		{
//LOG_MESSAGE(PLID,"Both strings, equal");
			strcat(parsed,"1");
		}
		else
		{
		char *endptr;
		int varValue,otherValue;

			varValue = strtol(res,&endptr,10);
			if(endptr==res || *endptr!='\0')
			{
//LOG_MESSAGE(PLID,"First is a string");
				strcat(parsed,"0");
			}
			else
			{
//LOG_MESSAGE(PLID,"First is a number : %d",varValue);
				otherValue = strtol(res2,&endptr,10);
				if(endptr==res2 || *endptr!='\0')
				{
//LOG_MESSAGE(PLID,"Second is a string");
					strcat(parsed,"0");
				}
				else
				{
//LOG_MESSAGE(PLID,"Second is a number : %d", otherValue);
					if(varValue==otherValue)
						strcat(parsed,"1");
					else
						strcat(parsed,"0");
				}
			}
		}
LOG_DBG_PARSER(("Comp result : %c",parsed[strlen(parsed)-1]));
	}
	else if(why=='!') // {something!something else}
	{
		res[0]='\0';
		res2[0]='\0';

		parseScript(res,first,query,pPlayer);
		parseScript(res2,second,query,pPlayer);
LOG_DBG_PARSER(("Compare != '%s' and '%s'",res,res2));


		if(!strcmp(res,res2))
		{
//LOG_MESSAGE(PLID,"Both strings, equal");
			strcat(parsed,"0");
		}
		else
		{
		char *endptr;
		int varValue,otherValue;

			varValue = strtol(res,&endptr,10);
			if(endptr==res || *endptr!='\0')
			{
//LOG_MESSAGE(PLID,"First is a string");
				strcat(parsed,"1");
			}
			else
			{
//LOG_MESSAGE(PLID,"First is a number : %d",varValue);
				otherValue = strtol(res2,&endptr,10);
				if(endptr==res2 || *endptr!='\0')
				{
//LOG_MESSAGE(PLID,"Second is a string");
					strcat(parsed,"1");
				}
				else
				{
//LOG_MESSAGE(PLID,"Second is a number : %d", otherValue);
					if(varValue==otherValue)
						strcat(parsed,"0");
					else
						strcat(parsed,"1");
				}
			}
		}
//LOG_DBG_PARSER(("Comp result : %c",parsed[strlen(parsed)-1]));
	}
	else if(why=='|')
	{
	bool v1, v2;
	char *endptr;
	int varValue;

		res[0]='\0';
		res2[0]='\0';

		parseScript(res,first,query,pPlayer);
		parseScript(res2,second,query,pPlayer);

		if(res[0]=='\0') // empty string : false
			v1 = false;
		else
		{
			varValue = strtol(res,&endptr,10);
			if(endptr==res || *endptr!='\0') // not a real integer : true
				v1 = true;
			else
				if(!varValue) // integer : 0
					v1 = false;
				else // integer : not null
					v1 = true;
		}

		if(res2[0]=='\0') // empty string : false
			v2 = false;
		else
		{
			varValue = strtol(res2,&endptr,10);
			if(endptr==res2 || *endptr!='\0') // not a real integer : true
				v2 = true;
			else
				if(!varValue) // integer : 0
					v2 = false;
				else // integer : not null
					v2 = true;
		}

		strcat(parsed,(v1||v2)?"1":"0");
	}
	else if(why=='&')
	{
	bool v1, v2;
	char *endptr;
	int varValue;

		res[0]='\0';
		res2[0]='\0';

		parseScript(res,first,query,pPlayer);
		parseScript(res2,second,query,pPlayer);

		if(res[0]=='\0') // empty string : false
			v1 = false;
		else
		{
			varValue = strtol(res,&endptr,10);
			if(endptr==res || *endptr!='\0') // not a real integer : true
				v1 = true;
			else
				if(!varValue) // integer : 0
					v1 = false;
				else // integer : not null
					v1 = true;
		}

		if(res2[0]=='\0') // empty string : false
			v2 = false;
		else
		{
			varValue = strtol(res2,&endptr,10);
			if(endptr==res2 || *endptr!='\0') // not a real integer : true
				v2 = true;
			else
				if(!varValue) // integer : 0
					v2 = false;
				else // integer : not null
					v2 = true;
		}

		strcat(parsed,(v1&&v2)?"1":"0");
	}
	else if(why=='@')
	{
	int len, max;
	bool found = false;

		parseScript(res,first,query,pPlayer);
		parseScript(res2,second,query,pPlayer);
		len = strlen(res);
		max = strlen(res2)-len;

		for(j=0;j<=max;j++)
		{
			if(!strncmp(res,res2+j,len))
			{
				if(j==0)
					strcat(parsed,"2");
				else if(j==max)
					strcat(parsed,"3");
				else
					strcat(parsed,"1");
				found = true;
				break;
			}
		}

		if(!found)
			strcat(parsed,"0");
	}

}
